/*
 * AndroidPortUtils.cpp
 *
 *  Created on: Jan 18, 2013
 *      Author: omergilad
 */

#include "AndroidPortUtils.h"

#include <sys/syscall.h>
#include <pthread.h>

void AndroidPortUtils::dumpBytesToFile(const byte* bytes, uint32 length,
		const char* filename) {
	LOGD("AndroidPortUtils::dumpBytesToFile: dumping %d bytes to %s", length, filename);

	FILE* file = fopen(filename, "w");

	if (file != NULL) {

		// Write all bytes
		uint32 index = 0;
		while (index < length) {
			index += fwrite(bytes, sizeof(byte), length - index, file);
		}

		fclose(file);
	}
}

//
// Additional macros missing from sched.h on Android
// http://stackoverflow.com/questions/16319725/android-set-thread-affinity
//
#define CPU_SETSIZE 1024
#define __NCPUBITS  (8 * sizeof (unsigned long))
typedef struct {
	unsigned long __bits[CPU_SETSIZE / __NCPUBITS];
} cpu_set_t;

#define CPU_SET(cpu, cpusetp) \
  ((cpusetp)->__bits[(cpu)/__NCPUBITS] |= (1UL << ((cpu) % __NCPUBITS)))
#define CPU_ZERO(cpusetp) \
  memset((cpusetp), 0, sizeof(cpu_set_t))

/*void AndroidPortUtils::setThreadCpuAffinity(int cpuNum) {
//	LOGD("AndroidPortUtils::setThreadCpuAffinity: %d", cpuNum);

	// Create the CPU mask
	cpu_set_t cpuset;
	CPU_ZERO(&cpuset);
	CPU_SET(cpuNum, &cpuset);

	int err, syscallres;
	pid_t pid = gettid();
	syscallres = syscall(__NR_sched_setaffinity, pid, sizeof(cpuset), &cpuset);
	if (syscallres) {
		err = errno;
		LOGE("Error in the syscall setaffinity: err=%d=0x%x",
				err, err);
	}
}*/

AndroidPortUtils::AndroidPortUtils() {
	// TODO Auto-generated constructor stub

}

AndroidPortUtils::~AndroidPortUtils() {
	// TODO Auto-generated destructor stub
}

