/*
 * SRTParser.h
 *
 *  Created on: Aug 11, 2014
 *      Author: omergilad
 */

#ifndef SRTPARSER_H_
#define SRTPARSER_H_

#include <istream>
#include <backends/platform/android/subtitles/SubtitleSequence.h>
#include "backends/platform/android/loghelper.h"


class SRTParser {
public:

	enum ParserState
	{
		NORMAL, BAD_INPUT, END_OF_FILE
	};

	SRTParser();
	virtual ~SRTParser();

	SubtitleSequence parseStream(std::istream& is);

	inline ParserState getParserState()
	{
		return mParserState;
	}

private:

	SubtitlePart parseNextPart(std::istream& is);

	uint64 parseNextTime(std::istream& is);

	bool isWhitespaceOnlyString(const std::string& str);

	inline void checkError(std::istream& is, std::string& lastLine)
	{
		if (is.fail())
		{
			mParserState = BAD_INPUT;
			LOGE("checkError: error, lastLine: %s", lastLine.c_str());
		}
	}

	ParserState mParserState;
};

#endif /* SRTPARSER_H_ */
