package org.iphsoft.simon1;

import org.iphsoft.simon1.AndroidPortAdditions.GameType;
import org.iphsoft.simon1.ui.ActivityAnimationUtil;
import org.iphsoft.simon1.util.BackgroundMusicPlayer;
import org.iphsoft.simon1.util.BitmapUtils;
import org.iphsoft.simon1.util.ImmersiveModeHelper;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

import com.dotemu.ihnmaims.R;

public class T7GSphinxDialogActivity extends Activity {

	public static final String EXTRA_MESSAGE = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_MESSAGE";
	public static final String EXTRA_POSITIVE_BUTTON = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_POSITIVE_BUTTON";
	public static final String EXTRA_NEGATIVE_BUTTON = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_NEGATIVE_BUTTON";

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);

		mImmersiveModeHelper = new ImmersiveModeHelper(this);

		setContentView(R.layout.dialog_activity);

		Intent intent = getIntent();
		String messageTxt = intent.getStringExtra(EXTRA_MESSAGE);
		String positiveButtonTxt = intent.getStringExtra(EXTRA_POSITIVE_BUTTON);
		String negativeButtonTxt = intent.getStringExtra(EXTRA_NEGATIVE_BUTTON);

		TextView txtTitle = (TextView) findViewById(R.id.txtTitle);
		TextView btnPositive = (TextView) findViewById(R.id.btnPositive);
		TextView btnNegative = (TextView) findViewById(R.id.btnNegative);

		txtTitle.setText(messageTxt);
		btnPositive.setText(positiveButtonTxt);
		btnNegative.setText(negativeButtonTxt);

		btnPositive.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				setResult(RESULT_OK);
				finish();
				ActivityAnimationUtil.makeActivityNullTransition(T7GSphinxDialogActivity.this);
			}
		});

		btnNegative.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				setResult(RESULT_CANCELED);
				finish();
				ActivityAnimationUtil.makeActivityNullTransition(T7GSphinxDialogActivity.this);
			}
		});

		BitmapUtils.setScaledBackground(this, findViewById(R.id.bg_frame), R.drawable.splash);
		BitmapUtils.setScaledBackground(this, findViewById(R.id.bg2), R.drawable.bg);
	}

	@Override
	protected void onResume()
	{
		super.onResume();

		mImmersiveModeHelper.supportFullScreenImmersiveMode();
	}

	@Override
	protected void onStart()
	{
		super.onStart();

		if (AndroidPortAdditions.HAS_BACKGROUND_MUSIC
				&& getIntent().getBooleanExtra(GameMenuActivity.EXTRA_MID_GAME, true) == false)
		{
			BackgroundMusicPlayer.addBackgroundMusicActivity();
		}
	}

	@Override
	protected void onStop()
	{
		super.onStop();

		if (AndroidPortAdditions.HAS_BACKGROUND_MUSIC
				&& getIntent().getBooleanExtra(GameMenuActivity.EXTRA_MID_GAME, true) == false)
		{
			BackgroundMusicPlayer.removeBackgroundMusicActivity();
		}
	}

	@Override
	public void onBackPressed()
	{
		super.onBackPressed();

		ActivityAnimationUtil.makeActivityNullTransition(T7GSphinxDialogActivity.this);
	}

	private ImmersiveModeHelper mImmersiveModeHelper;
}
