package org.iphsoft.simon1.ui;

import org.iphsoft.simon1.AndroidPortAdditions;
import org.iphsoft.simon1.AndroidPortAdditions.GameType;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.ImageButton;

import com.dotemu.ihnmaims.R;

public class ExtendedImageButton extends ImageButton {

	public ExtendedImageButton(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);

		init(context);
	}

	public ExtendedImageButton(Context context, AttributeSet attrs)
	{
		super(context, attrs);

		init(context);
	}

	public ExtendedImageButton(Context context)
	{
		super(context);

		init(context);
	}

	protected void init(Context context)
	{
		// Set button drawable
		setBackgroundResource(R.drawable.button_selector);

		// Set padding according to the different game menu buttons
		switch (AndroidPortAdditions.GAME_TYPE)
		{
		case SIMON1:
			setPadding(getPaddingLeft() / 2, getPaddingTop() / 2, getPaddingRight() / 2,
					getPaddingBottom() / 2);
			break;
		case SIMON2:
			setPadding(getPaddingLeft(), getPaddingTop(), getPaddingRight(), getPaddingBottom());
			break;
		case T7G:
			break;
		case FOTAQ:
		case IHNM:
			setPadding(getPaddingLeft(), getPaddingTop(), getPaddingRight(), getPaddingBottom());
			break;
		}
	}

	@Override
	public void setEnabled(boolean enabled)
	{
		// TODO Auto-generated method stub
		super.setEnabled(enabled);
	}
}
